<template>
  <v-dialog max-width="500" v-model="opened">
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        block
        outlined
        v-bind="attrs"
        v-on="on"
        class="text-none"
        large
        style="font-size: 18px; font-weight: 500; font-family: Montserrat sans-serif; line-height: 17px !important;"
      >
        <v-icon left>mdi-arrow-right-circle</v-icon>
        Вывести
      </v-btn>
    </template>
    <v-card>
      <v-toolbar dense color="secondary">
        <v-toolbar-title class="white--text">
          Вывести
        </v-toolbar-title>
        <v-spacer></v-spacer>
        <v-btn icon @click="opened = false"><v-icon>mdi-close</v-icon></v-btn>
      </v-toolbar>
      <qrcode-stream
        v-if="showScanner"
        style="border: 1px solid red"
        @decode="onDecode"
      ></qrcode-stream>
      <v-container v-else>
        <v-row justify="center">
          <v-col cols="12">
            <v-list>
              <asset-balance :balance="balance" />
            </v-list>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12">
            <v-text-field
              outlined
              v-model="recipientAddress"
              hide-details
              placeholder="Адрес получателя"
              append-icon="mdi-qrcode-scan"
              @click:append="scanQr"
            />
          </v-col>
          <v-col cols="12">
            <v-text-field
              outlined
              v-model="amount"
              hide-details
              placeholder="0.0"
            >
              <template v-slot:append>
                <v-btn small text @click="setMaxAmount">MAX</v-btn>
              </template>
            </v-text-field>
          </v-col>
          <v-col cols="12">
            <v-btn color="primary" block @click="withdraw" :disabled="sent"
              >Вывести</v-btn
            >
          </v-col>
          <v-col cols="12">
            <p>
              Для вывода используйте только реквизиты BEP20 токенов в сети BSC.
              В противном случае ваши токены могут быть навсегда утеряны
            </p>
          </v-col>
        </v-row>
      </v-container>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import { AccountResponse, TransferCommand } from '@/api/ledius-token';
import { FormattedBalance } from '@/store/exchange/balance';
import { toScaledBalance } from '@/utils';
import AssetBalance from '@/components/account/AssetBalance.vue';
import { QrcodeStream } from 'vue-qrcode-reader';

@Component({
  components: {
    AssetBalance,
    QrcodeStream
  }
})
export default class AccountWithdrawModal extends Vue {
  private opened: boolean = false;
  private sent: boolean = false;

  @Prop({
    required: true,
    type: Object
  })
  private readonly account!: AccountResponse;

  private recipientAddress: string = '';
  private amount: string = '';
  private showScanner: boolean = false;

  private get balance(): FormattedBalance {
    return this.$store.getters['exchange/balance/getBalanceBySymbol'](
      this.account,
      'LDS'
    );
  }

  private onDecode(decodedString: string): void {
    this.recipientAddress = decodedString?.split(':')[1] || '';
    this.showScanner = false;
  }

  private scanQr(): void {
    this.showScanner = true;
  }

  private async withdraw(): Promise<void> {
    this.sent = true;
    try {
      await this.$store.dispatch('exchange/balance/withdraw', {
        amount: toScaledBalance(this.amount),
        recipient: this.recipientAddress,
        sender: this.account.userId
      } as TransferCommand);
    } finally {
      this.sent = false;
    }
    this.opened = false;
  }

  private setMaxAmount(): void {
    this.amount = this.balance.formattedBalance;
  }
}
</script>

<style scoped></style>
